
<!--24.html의 문제점을 보완하는 과정
    panel이 먼저 보이고 그 위에 버튼이 보여야 한다.
    패널과 버튼이 슬라이드 처럼 나타났다가 사라지게 하길 원한다.
    while문이나 반복문을 사용하면 안된다. 
    그 이유는 화면과 같이 갱신이 필요하기 때문이다.
    자바스크립트의 프로그레스 바의 원리를 그대로 가지고 와서 구현한다.
-->

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        body {
            margin: 0;
            padding: 0;
        }
        
        #panel {
            background-color: lightgray;
            width: 300px;
            height: 100%;
            left: -300px;
            position: fixed;
            z-index: 0;        /*   페이지가 중첩이 될 때, 값이 클수록 렌더가 뒤늦게 된다.  */
        }
        #btn { 
            z-index: 1;        /*   페이지가 중첩이 될 때, 값이 클수록 렌더가 뒤늦게 된다.  */
            position:fixed;
            left: 0px;
            top: 200px;
        }
        .navbar{
            background-color: #263343;
            justify-content: center;
            align-items: center; 
            position: relative; 
            display: flex;          
        }
        /*  navbar클래스의 ul태그의 스타일을 변경  */
        .navbar > ul{
            display: flex;  list-style: none;   /*  리스트들을 가로로 보이게 하고, 리스트 목록 앞의 점을 제거   */
        }
        /*  navbar클래스의 ul태그의 li태그의 스타일을 변경  */
        .navbar > ul > li{
            color: white;
            padding: 8px 12px;  /*리스트들의 간격을 조정*/
        }
        /*  navbar클래스의 ul태그의 li태그의 a태그의 스타일을 변경  */
        .navbar > ul > li > a{
            color: white;
            padding: 8px 12px;  /*리스트들의 간격을 조정*/
            text-decoration: none;  /*a태그의 글자의 밑줄이 사라지게 한다.*/
        }
        /*   /*  navbar클래스의 ul태그의 li태그에 마우스가 갖다 댄 상태라면 배경색 변경*/
        .navbar > ul > li:hover{
            background-color: #d49466;
            border-radius: 4px; /*  테두리를 약간 둥근 사각형 처럼 보이게 설정  */
        }
        #panel > ul > li > a{
            color: red;
            font-size: medium;
            font-style:initial;
            text-decoration: none;  /*a태그의 글자의 밑줄이 사라지게 한다.*/
        }
        #panel > ul > li:hover{
            background-color: lightgreen;
            border-radius: 4px;
            display:inline;     /*배경색상이 글자길이만큼만 칠해지도록 설정*/
        }
        #panel > ul{
            border: 1px solid;  /*디버깅 용으로 아이디가 panel인 ul태그의 영역을 표시*/
        }
    </style>

    <script src="jquery-3.5.1.min.js"></script>
    <script>
    
        $(document).ready(function() 
        {
            //  버튼을 토글 기능으로 만들자.
            $('#btn').click(function() 
            {
                var p = document.getElementById('panel');
                var b = document.getElementById('btn');
                    

                //  패널이 안 보이는 상태에서 클릭 버튼을 누르면 패널이 보이면서 버튼도 같이 이동
                if ( $('#panel').css('left') == "-300px")
                {
                    //  panel의 left를 증가시킨다.
                    var left = -300;    //  현재 panel의 초기 left값
                    var dir = 1;
                    var id = setInterval(ShowOrHideframe,10);
                    var max = 0;        //  도달해야할 left값
                }
                else 
                {
                    var left = 0;    //  현재 panel의 초기 left값
                    var dir = -1;
                    var id = setInterval(ShowOrHideframe,10);
                    var max = -300;     //  도달해야할 left값
                }
                
                function ShowOrHideframe()
                {
                    //  0px에 도달하면 멈춤
                    if (left == max) 
                    {
                        p.style.left = left + "px";
                        
                        b.style.left = 300 + left + "px";   

                        clearInterval(id);
                    }
                    else
                    {
                        left = left + 10*(dir);
                        
                        p.style.left = left + "px";

                        b.style.left = 300 + left + "px";   //  button의 위치는 0px에서부터 시작.
                    }
                }

                function Showframe()
                {
                    //  0px에 도달하면 멈춤
                    if (left >= 0)
                    {
                        left = 0;
                        
                        p.style.left = left + "px";
                        
                        b.style.left = 300 + left + "px";   //  button의 위치는 0px에서부터 시작.

                        clearInterval(id);
                    }
                    else
                    {
                        left = left + 10;
                        
                        p.style.left = left + "px";

                        b.style.left = 300 + left + "px";   //  button의 위치는 0px에서부터 시작.
                    }
                }

                function Hideframe()
                {
                     //  -300px에 도달하면 멈춤
                     if (left <= -300)
                    {
                        left = -300;
                        
                        p.style.left = left + "px";
                        
                        b.style.left = 300 + left + "px";   //  button의 위치는 0px에서부터 시작.

                        clearInterval(id);
                    }
                    else
                    {
                        left = left - 10;
                        
                        p.style.left = left + "px";

                        b.style.left = 300 + left + "px";   //  button의 위치는 0px에서부터 시작.
                    }
                }
            })
        });
    </script>

</head>

<body>

    <!--nav 태그에서 메뉴를 만들면 된다.-->
    <nav class="navbar">
        <ul>
            <li><a href="#">HOME</a></li>
            <li><a href="#">HOME</a></li>
            <li><a href="#">HOME</a></li>
            <li><a href="#">HOME</a></li>
            <li><a href="#">HOME</a></li>
        </ul>
    </nav>

    <div id = panel> 
        <ul>
            <li><a href="http://www.naver.com">HOME</a></li>
            <li><a href="#">회사소개</a></li>
            <li><a href="#">서비스</a></li>
            <li><a href="#">고객센터</a></li>
            <li><a href="#">게시판</a></li>
        </ul>
    </div>

    <!--<button id=btn onclick=panel()>panel</button>-->
    <button id=btn>panel</button>

</body>

</html>